# f[^e[u̍쐬
sub create_tables {
	local($cn, $ps, $rs, @dbdtables, @dbctables, @tablesname, @columnsname, @temptables, $query, $i, $j, $errflg);
	
	$errflg = 0;
	$cn = &get_connection;
	
	eval {
		# TABLEXg
		@tablesname = ('MESSAGE', 'MEMBER', 'MEMBER_BACK', 'MEMBER_ALL', 'PARTY', 'FILE', 'FILE_TO', 'VERSION');
		
		# e[u`
		@dbctables = ();
		# MESSAGE
		$i = 0;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_MESSAGE (
  MESSAGE_NAME VARCHAR(100),
  MESSAGE_IP VARCHAR(015),
  MESSAGE_COLOR VARCHAR(006),
  MESSAGE_TEXT BLOB,
  MESSAGE_TIME DATETIME,
  MESSAGE_SEQ INTEGER,
  CONSTRAINT PK_[#name#]_MESSAGE PRIMARY KEY (
    MESSAGE_TIME,
	MESSAGE_SEQ
  )
) TYPE = InnoDB
EOM
		# MEMBER
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_MEMBER (
  MEMBER_NAME VARCHAR(100),
  MEMBER_IP VARCHAR(015),
  MEMBER_COLOR VARCHAR(006),
  MEMBER_TIME DATETIME,
  MEMBER_INTERVAL INTEGER,
  MEMBER_ID VARCHAR(052),
  MEMBER_STATUS VARCHAR(020),
  MEMBER_NO INTEGER
) TYPE = InnoDB
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_MEMBER_IDX01 ON [#name#]_MEMBER (
  MEMBER_IP,
  MEMBER_ID,
  MEMBER_TIME
)
EOM
		# MEMBER_BACK
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_MEMBER_BACK (
  MEMBER_BACK_ID VARCHAR(052),
  MEMBER_BACK_IP VARCHAR(015),
  MEMBER_BACK_TIME DATETIME
) TYPE = InnoDB
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_MEMBER_BACK_IDX01 ON [#name#]_MEMBER_BACK (
  MEMBER_BACK_IP,
  MEMBER_BACK_ID,
  MEMBER_BACK_TIME
)
EOM
		# MEMBER_ALL
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_MEMBER_ALL (
  MEMBER_ALL_NAME VARCHAR(100),
  MEMBER_ALL_IP VARCHAR(015),
  MEMBER_ALL_TIME DATETIME,
  MEMBER_ALL_ID VARCHAR(052)
) TYPE = InnoDB
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_MEMBER_ALL_IDX01 ON [#name#]_MEMBER_ALL (
  MEMBER_ALL_IP,
  MEMBER_ALL_ID,
  MEMBER_ALL_TIME
)
EOM
		# PARTY
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_PARTY (
  PARTY_NO INTEGER,
  PARTY_IP VARCHAR(052),
  PARTY_SP INTEGER,
  PARTY_PM VARCHAR(100),
  CONSTRAINT PK_[#name#]_PARTY PRIMARY KEY (
    PARTY_NO
  )
) TYPE = InnoDB
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_PARTY_IDX01 ON [#name#]_PARTY (
  PARTY_IP,
  PARTY_SP
)
EOM
		# FILE
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_FILE (
  FILE_ID VARCHAR(200),
  FILE_NAME VARCHAR(200),
  FILE_DESCRIPTION VARCHAR(200),
  FILE_EXPIRE DATETIME,
  FILE_IP VARCHAR(052),
  FILE_TYPE VARCHAR(256),
  FILE_NO INTEGER,
  CONSTRAINT PK_[#name#]_FILE PRIMARY KEY (
    FILE_ID
  )
) TYPE = InnoDB
EOM
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE INDEX [#name#]_FILE_IDX01 ON [#name#]_FILE (
  FILE_EXPIRE
)
EOM
		# FILE_TO
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE [#name#]_FILE_TO (
  FILE_ID VARCHAR(200),
  FILE_TOIP VARCHAR(052),
  CONSTRAINT PK_[#name#]_FILE_TO PRIMARY KEY (
    FILE_ID,
	FILE_TOIP
  )
) TYPE = InnoDB
EOM
		# VERSION
		$i ++;
		$dbctables[$i] = <<EOM;
CREATE TABLE IF NOT EXISTS [#name#]_VERSION (
  VERSION_NO VARCHAR(020),
  VERSION_DATE DATETIME,
  VERSION_FLG TINYINT,
  CONSTRAINT PK_[#name#]_VERSION PRIMARY KEY (
    VERSION_NO
  )
) TYPE = InnoDB
EOM
		
		# č쐬̏ꍇATEMPe[u̍폜ƍ쐬
		if ($_[1]) {
			@temptables = ();
			@columnsname = ();
			$query = 'SHOW TABLES';
			$ps = $cn->prepare($query);
			$ps->execute;
			while ($rs = $ps->fetch) {	push(@temptables, ${$rs}[0]);	}
			$ps->finish;
			for ($i = 0; $i <= $#tablesname; $i ++) {
				if (grep(/^$_[0]_$tablesname[$i]$/, @temptables)) {
					$j = 0;
					$query = "DESCRIBE $_[0]" . "_$tablesname[$i]";
					$ps = $cn->prepare($query);
					$ps->execute;
					while ($rs = $ps->fetch) {
						$columnsname[$i][$j] = ${$rs}[0];
						$j ++;
					}
					$ps->finish;
					$query = "DROP TABLE IF EXISTS $_[0]" . "_$tablesname[$i]" . "_TEMP";
					$ps = $cn->prepare($query);
					$ps->execute;
					$ps->finish;
					$query = "ALTER TABLE $_[0]" . "_$tablesname[$i]" . " RENAME TO $_[0]" . "_$tablesname[$i]" . '_TEMP';
					$ps = $cn->prepare($query);
					$ps->execute;
					$ps->finish;
				} else {	@{$columnsname[$i]} = ();	}
			}
		# ʏ쐬̏ꍇA݃e[u̍폜
		} else {
			# DROP
			for ($i = 0; $i <= $#tablesname; $i ++) {
				$query = "DROP TABLE IF EXISTS $_[0]" . "_$tablesname[$i]";
				$ps = $cn->prepare($query);
				$ps->execute;
				$ps->finish;
			}
		}
		
		# CREATE
		for ($i = 0; $i <= $#dbctables; $i ++) {
			$query = $dbctables[$i];
			$query =~ s/\[#name#\]/$_[0]/g;
			$ps = $cn->prepare($query);
			$ps->execute;
			$ps->finish;
		}
		
		# č쐬̏ꍇATEMPe[üڍsTEMPe[u̍폜
		if ($_[1]) {
			for ($i = 0; $i <= $#tablesname; $i ++) {
				if ($#{$columnsname[$i]} < 0) {	next;	}
				$query = "INSERT INTO $_[0]" . "_$tablesname[$i] (";
				for ($j = 0; $j <= $#{$columnsname[$i]}; $j ++) {
					if ($j == 0) {	$query .= $columnsname[$i][$j];	}
					else {	$query .= ", $columnsname[$i][$j]";	}
				}
				$query .= ') SELECT ';
				for ($j = 0; $j <= $#{$columnsname[$i]}; $j ++) {
					if ($j == 0) {	$query .= $columnsname[$i][$j];	}
					else {	$query .= ", $columnsname[$i][$j]";	}
				}
				$query .= " FROM $_[0]" . "_$tablesname[$i]" . '_TEMP';
				$ps = $cn->prepare($query);
				$ps->execute;
				$ps->finish;
				$query = "DROP TABLE IF EXISTS $_[0]" . "_$tablesname[$i]" . '_TEMP';
				$ps = $cn->prepare($query);
				$ps->execute;
				$ps->finish;
			}
			$query = 'UPDATE [#name#]_VERSION SET VERSION_FLG = 1 WHERE VERSION_NO = ?';
			$query =~ s/\[#name#\]/$_[0]/g;
			$ps = $cn->prepare($query);
			if ($ps->execute($dbversion) <= 0) {
				$ps->finish;
				$query = 'INSERT INTO [#name#]_VERSION (VERSION_NO, VERSION_DATE, VERSION_FLG) VALUES (?, SYSDATE(), 1)';
				$query =~ s/\[#name#\]/$_[0]/g;
				$ps = $cn->prepare($query);
				$ps->execute($dbversion);
			}
			$ps->finish;
			$query = 'UPDATE [#name#]_VERSION SET VERSION_FLG = 0 WHERE VERSION_NO != ?';
			$query =~ s/\[#name#\]/$_[0]/g;
			$ps = $cn->prepare($query);
			$ps->execute($dbversion);
			$ps->finish;
		# ʏ쐬̏ꍇAT[o[f[^̈ڍs
		} else {	$errflg = &update_tables($_[0]);	}
	};
	if ($@) {	$errflg = $@;	}
	
	return $errflg;
}


# f[^x[X̃NA
sub truncate_tables {
	local($cn, $ps, $query, @dbttables, $i, $errflg);
	
	$errflg = 0;
	$cn = &get_connection;
	
	eval {
		# TRUNCATEXg
		@dbttables = ('MESSAGE', 'MEMBER', 'MEMBER_BACK', 'MEMBER_ALL', 'PARTY', 'FILE');
		# TRUNCATE
		for ($i = 0; $i <= $#dbttables; $i ++) {
			$query = "TRUNCATE TABLE $_[0]" . "_$dbttables[$i]";
			$query =~ s/\[#name#\]/$_[0]/g;
			$ps = $cn->prepare($query);
			$ps->execute;
			$ps->finish;
		}
		
		$errflg = &update_tables($_[0]);
	};
	if ($@) {	$errflg = $@;	}
	
	return $errflg;
}


# [Jf[^̃Abvf[g
sub update_tables {
	local($cn, $ps, $query, $flist, $yyyy, $mm, $dd, $hh, $mi, $sec, @date_str, $i, $j, $k, $errflg);
	
	$errflg = 0;
	$cn = &get_connection;
	
	eval {
		# MESSAGE
		$query = <<EOM;
INSERT INTO [#name#]_MESSAGE (
  MESSAGE_NAME,
  MESSAGE_IP,
  MESSAGE_COLOR,
  MESSAGE_TEXT,
  MESSAGE_TIME,
  MESSAGE_SEQ
) VALUES (?, ?, ?, ?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'), ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&message_decode;
		$ps = $cn->prepare($query);
		for ($i = $#message_name; $i >= 0; $i --) {
			($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($message_time[$i]);
			$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
			if ($i < $#message_name && $message_time[$i] == $message_time[$i + 1] && $message_seq[$i] == $message_seq[$i + 1]) {	$message_seq[$i] ++;	}
			$ps->execute($message_name[$i], $message_ip[$i], $message_color[$i], $message_text[$i], $date_str[0], $message_seq[$i]);
		}
		$ps->finish;
		# MEMBER
		$query = <<EOM;
INSERT INTO [#name#]_MEMBER (
  MEMBER_NAME,
  MEMBER_IP,
  MEMBER_COLOR,
  MEMBER_TIME,
  MEMBER_INTERVAL,
  MEMBER_ID,
  MEMBER_STATUS,
  MEMBER_NO
) VALUES (?, ?, ?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'), ?, ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&member_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#member_name; $i ++) {
			($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($member_time[$i]);
			$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
			$ps->execute($member_name[$i], $member_ip[$i], $member_color[$i], $date_str[0], $member_interval[$i], $member_id[$i], $member_status[$i], $i + 1);
		}
		$ps->finish;
		# MEMBER_BACK
		$query = <<EOM;
INSERT INTO [#name#]_MEMBER_BACK (
  MEMBER_BACK_ID,
  MEMBER_BACK_IP,
  MEMBER_BACK_TIME
) VALUES (?, ?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'))
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&member_back_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#member_back_id; $i ++) {
			($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($member_back_time[$i]);
			$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
			$ps->execute($member_back_id[$i], $member_back_ip[$i], $date_str[0]);
		}
		$ps->finish;
		# MEMBER_ALL
		$query = <<EOM;
INSERT INTO [#name#]_MEMBER_ALL (
  MEMBER_ALL_NAME,
  MEMBER_ALL_IP,
  MEMBER_ALL_TIME,
  MEMBER_ALL_ID
) VALUES (?, ?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'), ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&member_all_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#member_all_name; $i ++) {
			($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($member_all_time[$i]);
			$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
			$ps->execute($member_all_name[$i], $member_all_ip[$i], $date_str[0], $member_all_id[$i]);
		}
		$ps->finish;
		# PARTY
		$query = <<EOM;
INSERT INTO [#name#]_PARTY (
  PARTY_NO,
  PARTY_IP,
  PARTY_SP,
  PARTY_PM
) VALUES (?, ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&party_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#party_ip; $i ++) {	$ps->execute($i + 1, $party_ip[$i], $party_sp[$i], $party_pm[$i]);	}
		$ps->finish;
		# FILE
		$query = <<EOM;
INSERT INTO [#name#]_FILE (
  FILE_ID,
  FILE_NAME,
  FILE_DESCRIPTION,
  FILE_EXPIRE,
  FILE_IP,
  FILE_TYPE,
  FILE_NO
) VALUES (?, ?, ?, STR_TO_DATE(?, '%Y/%m/%d %H:%i:%s'), ?, ?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&file_decode;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#file_id; $i ++) {
			($sec, $mi, $hh, $dd, $mm, $yyyy) = localtime($file_expire[$i]);
			$date_str[0] = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $yyyy + 1900, $mm + 1, $dd, $hh, $mi, $sec);
			$ps->execute($file_id[$i], $file_name[$i], $file_description[$i], $date_str[0], $file_ip[$i], $file_type[$i], $i + 1);
		}
		$ps->finish;
		# FILE_TO
		$query = <<EOM;
INSERT INTO [#name#]_FILE_TO (
  FILE_ID,
  FILE_TOIP
) VALUES (?, ?)
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#file_id; $i ++) {
			@date_str = split(/\|/, $file_toip[$i]);
			for ($j = 0; $j <= $#date_str; $j ++) {
				if ($date_str[$j]) {$ps->execute($file_id[$i], $date_str[$j]);	}
			}
		}
		$ps->finish;
		
		$cn->do('COMMIT');
	};
	if ($@) {
		$errflg = $@;
		$cn->do('ROLLBACK');
	}
	
	return $errflg;
}


# [Jf[^ɃobNAbv
sub backup_tables {
	local($cn, $ps, $rs, $query, @tempstr, $yyyy, $mm, $dd, $hh, $mi, $sec, $i, $errflg);
	
	$errflg = 0;
	$cn = &get_connection;
	
	eval {
		# MESSAGE
		$query = <<EOM;
SELECT
  MESSAGE_NAME,
  MESSAGE_IP,
  MESSAGE_COLOR,
  MESSAGE_TEXT,
  DATE_FORMAT(MESSAGE_TIME, '%Y/%m/%d/%H/%i/%s'),
  MESSAGE_SEQ
FROM [#name#]_MESSAGE
ORDER BY MESSAGE_TIME DESC, MESSAGE_SEQ DESC
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&message_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@message_name, ${$rs}[0]);
			push(@message_ip, ${$rs}[1]);
			push(@message_color, ${$rs}[2]);
			push(@message_text, ${$rs}[3]);
			push(@message_time, &get_timevalue(split(/\//, ${$rs}[4])));
			push(@message_seq, ${$rs}[5]);
		}
		$ps->finish;
		$message_open = 1;
		&message_save;
		# MEMBER
		$query = <<EOM;
SELECT
  MEMBER_NAME,
  MEMBER_IP,
  MEMBER_COLOR,
  DATE_FORMAT(MEMBER_TIME, '%Y/%m/%d/%H/%i/%s'),
  MEMBER_INTERVAL,
  MEMBER_ID,
  MEMBER_STATUS
FROM [#name#]_MEMBER
ORDER BY MEMBER_NO
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&member_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@member_name, ${$rs}[0]);
			push(@member_ip, ${$rs}[1]);
			push(@member_color, ${$rs}[2]);
			push(@member_time, &get_timevalue(split(/\//, ${$rs}[3])));
			push(@member_interval, ${$rs}[4]);
			push(@member_id, ${$rs}[5]);
			push(@member_status, ${$rs}[6]);
		}
		$ps->finish;
		$member_open = 1;
		&member_save;
		# MEMBER_BACK
		$query = <<EOM;
SELECT
  MEMBER_BACK_ID,
  MEMBER_BACK_IP,
  DATE_FORMAT(MEMBER_BACK_TIME, '%Y/%m/%d/%H/%i/%s')
FROM [#name#]_MEMBER_BACK
ORDER BY MEMBER_BACK_TIME DESC
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&member_back_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@member_back_id, ${$rs}[0]);
			push(@member_back_ip, ${$rs}[1]);
			push(@member_back_time, &get_timevalue(split(/\//, ${$rs}[2])));
		}
		$ps->finish;
		$member_back_open = 1;
		&member_back_save;
		# MEMBER_ALL
		$query = <<EOM;
SELECT
  MEMBER_ALL_NAME,
  MEMBER_ALL_IP,
  DATE_FORMAT(MEMBER_ALL_TIME, '%Y/%m/%d/%H/%i/%s'),
  MEMBER_ALL_ID
FROM [#name#]_MEMBER_ALL
ORDER BY MEMBER_ALL_TIME DESC
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&member_all_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@member_all_name, ${$rs}[0]);
			push(@member_all_ip, ${$rs}[1]);
			push(@member_all_time, &get_timevalue(split(/\//, ${$rs}[2])));
			push(@member_all_id, ${$rs}[3]);
		}
		$ps->finish;
		$member_all_open = 1;
		&member_all_save;
		# FILE
		$query = <<EOM;
SELECT
  FILE_ID,
  FILE_NAME,
  FILE_DESCRIPTION,
  DATE_FORMAT(FILE_EXPIRE, '%Y/%m/%d/%H/%i/%s'),
  FILE_IP,
  FILE_TYPE
FROM [#name#]_FILE
ORDER BY FILE_NO
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		&file_initialize;
		$ps = $cn->prepare($query);
		$ps->execute;
		while ($rs = $ps->fetch) {
			push(@file_id, ${$rs}[0]);
			push(@file_name, ${$rs}[1]);
			push(@file_description, ${$rs}[2]);
			push(@file_expire, &get_timevalue(split(/\//, ${$rs}[3])));
			push(@file_ip, ${$rs}[4]);
			push(@file_type, ${$rs}[5]);
		}
		$ps->finish;
		$query = <<EOM;
SELECT
  FILE_TOIP
FROM [#name#]_FILE_TO
WHERE FILE_ID = ?
EOM
		$query =~ s/\[#name#\]/$_[0]/g;
		$ps = $cn->prepare($query);
		for ($i = 0; $i <= $#file_id; $i ++) {
			@tempstr = ();
			$ps->bind_param(1, $file_id[$i]);
			$ps->execute;
			while ($rs = $ps->fetch) {	push(@tempstr, ${$rs}[0]);	}
			if ($#tempstr >= 0) {	$file_toip[$i] = join('|', @tempstr);;	}
		}
		$ps->finish;
		$filelist_open = 1;
		&filelist_save;
	};
	if ($@) {	$errflg = $@;	}
	
	return $errflg;
}


1;

__END__

